/*------------------------------------------------------------------
 rcktldef.h - rocket port hardware definitions, dependent os code here!

8-08-95 rewrite, strip out bogus typedefs, extra globals, etc. - kpb
LAST UPDATE:11-03-95 11:33 P.M.
 Copyright (c) 1995 Comtrol Corporation
|---------------------------------------------------------------------*/
// Choose one of these or define a new one
//#define WC_16
//#define BC_16
//#define MS_16
//#define MS_32

#define WANT_BASE_TYPES

#ifdef WANT_BASE_TYPES
typedef unsigned char  BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef int BOOL;
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

//#define SET_LOCK   disable()
//#define CLEAR_LOCK enable()

#define SET_LOCK   
#define CLEAR_LOCK 

/*------ Setup for use with WATCOM C/386 and the WC_16 NLM SDK ------*/
#ifdef WC_16

#include <conio.h>

#define ASM asm

#define sEnable() enable()
#define sDisable() disable()

#define sOutB(a,b) outp(a,b)
#define sOutW(a,b) outpw(a,b)
#define sOutDW(a,b) outpd(a,b)
#define sInB(a) (inp(a))
#define sInW(a) (inpw(a))

void sOutStrW(word, WORD *, WORD);
#pragma aux sOutStrW =   \
  "  cld"                \
  "  rep outsw",         \
  parm [ EDX ] [ ESI ] [ ECX ]  \
  modify [ ESI ECX ];

void sInStrW(word, WORD *, WORD);
#pragma aux sInStrW =  \
  "  cld"              \
  "  rep insw",        \
  parm [ EDX ] [ EDI ] [ ECX ]  \
  modify [ EDI ECX ];
#endif

/*------ Setup for use with BORLAND C++ 3.1 ---------------------*/
#ifdef BC_16

#include <dos.h>
#define ASM asm

#define sEnable() enable()
#define sDisable() disable()

#define sOutB(a, b) outp(a, b)
#define sOutW(a, b) outpw(a, b)
#define sInB(a) (inp(a))
#define sInW(a) (inpw(a))

// generate a 386/486 outdw function
#define sOutDW(a, b) \
{\
  _DX= (a);\
  __emit__(0x66);\
  _AX= (b);\
  __emit__(0x66,0xef);\
}

// alternate to above(simple), the emits can be problem running extenders
#define sOutSimpleDW(a, b) \
{\
  outpw(a, (unsigned int) b);\
  outpw(a+2,b >> 16);\
}\

#define sOutStrW(a, b, c) \
{\
  _DS= FP_SEG((b));\
  _SI= FP_OFF((b));\
  _CX= (c);\
  _DX= (a);\
  __emit__(0xfc);\
  __emit__(0xf3,0x6f);\
}

#define sInStrW(a, b, c)\
{\
  _ES= FP_SEG((b));\
  _DI= FP_OFF((b));\
  _CX= (c);\
  _DX= (a);\
  __emit__(0xfc);\
  __emit__(0xf3,0x6d);\
}
#endif

/*------ Setup for use with Microsoft 32-bit ---------------------*/
#ifdef MS_32
#endif

/*------ Setup for use with Microsoft 16-bit ---------------------*/
#ifdef MS_16

#define ASM _asm

#define sEnable() _enable()
#define sDisable() _disable()

#define sOutB(IO,VAL) _outp(IO,VAL)
#define sOutW(IO,VAL) _outpw(IO,VAL)
// #define sOutDW(IO,VAL) _outpd(IO,VAL) only in 32-bit
#define sInB(IO) (_inp(IO))
#define sInW(IO) (_inpw(IO))

// generate a 386/486 outdw function
// alternate to above(simple), the emits can be problem running extenders
// Better to have it done in one instruction - avoid hardware contention
// problems
#define sOutDW(a, b) \
{\
  outpw(a, (unsigned int) b);\
  outpw(a+2,b >> 16);\
}\

#define sOutStrW(IO,BUFFER,COUNT) \
{ \
   while((COUNT)-- > 0) \
     sOutW(IO,*((unsigned short *) BUFFER)++); \
}

// this definition needs a WORD ptr!!!!!!
#define sInStrW(IO,BUFFER,COUNT) \
{ \
   while((COUNT)-- > 0) \
      *(BUFFER)++ = sInW(IO); \
}

#endif
