/*--------------------------------------------------------------------------
 rkt.c - test dos hook
|---------------------------------------------------------------------------*/
#include <stdio.h>
#include <dos.h>
#include <mem.h>

struct dos_name_dev {
  struct dev *next;
  unsigned int attr;
  unsigned int strat;
  unsigned int inter;
  char name[8];
};

/*----------------------------------------------------------------------------
| main -
|----------------------------------------------------------------------------*/
int main(int argc, char *argv[])
{
  int i;
  int stat, j;
  int help_flag = 0;
  char *buf;
  struct dos_name_dev *dv;
  struct dos_name_dev *dv_l1;
  struct dos_name_dev *dv_l2;
  char tmpstr[20];

  for (i=1; i<argc; i++)
  {
    buf = argv[i];
    if ((*buf == '-') || (*buf == '/'))
    {
      ++buf;
      switch(*buf++)
      {
        case 'H': help_flag = 1; break;
        default:
          puts("Bad option");
          help_flag = 1;
        break;
      }
    }
    else
    {
      puts("Expecting Option -##");
    }
  }

  if (help_flag)
  {
    puts("Use>rkt -options");
    puts("Where options:");
    puts("-h   This help.");
    puts("Example>rfsmall  -p180 -c3 -l38400");
    return(-1);
  }


  buf = (char *)0x400L;
  dv = NULL;

  // search for dos devices
  for (i=0; i<10000; i++)
  {
    if ((buf[0] == 'A') && (buf[1] == 'U') &&
        (buf[2] == 'X') && (buf[3] == ' '))
    {
      dv = (struct dv *) (buf - 10);
      break;
    }
    ++buf;
  }

  if (dv == NULL)
  {
    printf("Could not find device chain\n");
    exit(1);
  }

  do {
    for (i=0; i<8; i++)
    {
      tmpstr[i] = dv->name[i];
      if (tmpstr[i] == ' ')
        tmpstr[i] = '_';
      if ((tmpstr[i] > 0x80) || (tmpstr[i] <= 0x20))
        tmpstr[i] = '.';
    }
    tmpstr[8] = 0;

    printf("%8s> attr:%x, seg:%x strat:%x intr:%x next %x:%x\n",
      tmpstr, dv->attr, FP_SEG(dv), dv->strat, dv->inter,
      FP_SEG(dv->next), FP_OFF(dv->next));

    dv_l2 = dv_l1;
    dv_l1 = dv;
    dv = dv->next;
  }
  while (dv != -1L);

  if ((dv_l1->name[0] == 'C') && (dv_l1->name[1] == 'O'))
  {
    puts("Kill last?");
    if ((getch() == 'y') || (getch() == 'Y'))
    {
      dv_l2->next = -1L;
      puts("Kill Com end");
    }
  }
}


