#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <io.h>
#include <conio.h>
#include <mem.h>

#define TRUE 1
#define FALSE 0

// reduce heap and stack length for TSR
extern unsigned _heaplen= 1;
extern unsigned _stklen= 1024;

extern void SNIFFIsr14();

unsigned long	OldIsr14;

#define PORT 0x3f8

void ComInit(void)
{
	outp(PORT+3,0x80);		// DLAB= 1
	outp(PORT+0,0x06);		// 19200 baud
	outp(PORT+1,0);
	outp(PORT+3,3);			// 8 bits, no parity
	outp(PORT+4,3);			// DTR + RTS true
}

void ComPutc(char c)
{
	while ((inp(PORT+5) & 0x20) == 0) ;
	outp(PORT,c);
}

void ComPuts(char *s)
{
	while (*s)
	{	ComPutc(*s);
		s++;
	}
}

void ComPutHex1(unsigned char val)
{
	ComPutc( (val < 10) ? (val + 0x30) : (val + 0x37));
}

void ComPutHex16(unsigned int val)
{
	char b;

	b= (val & 0xf000) >> 12;
	ComPutHex1(b);
	b= (val & 0x0f00) >> 8;
	ComPutHex1(b);
	b= (val & 0x00f0) >> 4;
	ComPutHex1(b);
	b= (val & 0x000f);
	ComPutHex1(b);
}

void SNIFFInt14Before(void)
{
	static unsigned regAX, regBX, regCX, regDX;

	regAX= _AX;
	regBX= _BX;
	regCX= _CX;
	regDX= _DX;

	ComPuts("Call: AX= ");
	ComPutHex16(regAX);
	ComPuts(" BX= ");
	ComPutHex16(regBX);
	ComPuts(" CX= ");
	ComPutHex16(regCX);
	ComPuts(" DX= ");
	ComPutHex16(regDX);
	ComPuts("\r\n");
}

void SNIFFInt14After(void)
{
	static unsigned regAX, regBX, regCX, regDX;

	regAX= _AX;
	regBX= _BX;
	regCX= _CX;
	regDX= _DX;

	ComPuts("      AX= ");
	ComPutHex16(regAX);
	ComPuts(" BX= ");
	ComPutHex16(regBX);
	ComPuts(" CX= ");
	ComPutHex16(regCX);
	ComPuts(" DX= ");
	ComPutHex16(regDX);
	ComPuts("\r\n");
}

int main(void)
{

	OldIsr14= (unsigned long) getvect(0x14);
	setvect(0x14,(void interrupt (*)())SNIFFIsr14);

	ComInit();
	ComPuts("\r\ni14 Sniffer loaded...\r\n\n");

	fprintf(stderr,"i14 Sniffer loaded...\n");

	close(0);
	close(1);
	close(2);
	close(3);

	keep(0,(_SS + ((_SP + 128)/16) - _psp));
	return(0);
}
